it-swarm.com.ru

Какой краткий способ проверить, что переменные среды установлены в сценарии оболочки Unix?

У меня есть несколько сценариев Unix Shell, где мне нужно проверить, установлены ли определенные переменные среды, прежде чем я начну что-то делать, поэтому я делаю такие вещи:

if [ -z "$STATE" ]; then
    echo "Need to set STATE"
    exit 1
fi  

if [ -z "$DEST" ]; then
    echo "Need to set DEST"
    exit 1
fi

что много печатать. Есть ли более элегантная идиома для проверки того, что установлен набор переменных среды?

Правка: я должен отметить, что эти переменные не имеют значащего значения по умолчанию - скрипт должен выдавать ошибку, если какие-либо не установлены.

472
AndrewR

Расширение параметра

Очевидный ответ - использовать одну из специальных форм расширения параметров:

: ${STATE?"Need to set STATE"}
: ${DEST:?"Need to set DEST non-empty"}

Или лучше (см. Раздел "Положение двойных кавычек" ниже):

: "${STATE?Need to set STATE}"
: "${DEST:?Need to set DEST non-empty}"

Первый вариант (с использованием только ?) требует установки STATE, но STATE = "" (пустая строка) в порядке - не совсем то, что вы хотите, но альтернативная и более старая нотация.

Второй вариант (с использованием :?) требует, чтобы DEST был установлен и не был пустым.

Если вы не укажете сообщение, командная консоль предоставит сообщение по умолчанию.

Конструкция ${var?} переносима обратно в Версию 7 UNIX и Bourne Shell (1978 или около того). Конструкция ${var:?} немного новее: я думаю, что она была в System III UNIX примерно в 1981 году, но до этого она могла быть в PWB UNIX. Поэтому он находится в оболочке Korn и в оболочках POSIX, включая, в частности, Bash.

Обычно это документируется на странице руководства Shell в разделе Расширение параметров . Например, руководство bash гласит:

${parameter:?word}

Ошибка дисплея, если ноль или не установлен. Если параметр имеет значение null или не установлен, расширение Word (или сообщение на этот счет, если Word отсутствует) записывается со стандартной ошибкой, и командная консоль, если она не является интерактивной, завершается. В противном случае значение параметра подставляется.

Колонское командование

Я, вероятно, должен добавить, что команда двоеточия просто оценивает свои аргументы и затем успешно. Это оригинальная запись комментария оболочки (перед '#' до конца строки). Долгое время сценарии Bourne Shell имели двоеточие в качестве первого символа. Оболочка C считывает сценарий и использует первый символ, чтобы определить, относится ли он к оболочке C (хэш #) или к оболочке Bourne (двоеточие :). Затем ядро ​​приняло участие и добавило поддержку "#!/path/to/program", а оболочка Bourne получила комментарии "#", и соглашение о двоеточии отошло на второй план. Но если вы встретите сценарий, который начинается с двоеточия, теперь вы будете знать, почему.


Положение двойных кавычек

blong спросил в комментарий :

Есть мысли по поводу этой дискуссии? https://github.com/koalaman/shellcheck/issues/380#issuecomment-145872749

Суть обсуждения:

… Однако, когда я shellcheck (с версией 0.4.1), я получаю это сообщение:

In script.sh line 13:
: ${FOO:?"The environment variable 'FOO' must be set and non-empty"}
  ^-- SC2086: Double quote to prevent globbing and Word splitting.

Любой совет, что мне делать в этом случае?

Краткий ответ: "делай, как предлагает shellcheck":

: "${STATE?Need to set STATE}"
: "${DEST:?Need to set DEST non-empty}"

Чтобы проиллюстрировать почему, изучите следующее. Обратите внимание, что команда : не отображает свои аргументы (но Shell действительно оценивает аргументы). Мы хотим видеть аргументы, поэтому код ниже использует printf "%s\n" вместо :.

$ mkdir junk
$ cd junk
$ > abc
$ > def
$ > ghi
$ 
$ x="*"
$ printf "%s\n" ${x:?You must set x}    # Careless; not recommended
abc
def
ghi
$ unset x
$ printf "%s\n" ${x:?You must set x}    # Careless; not recommended
bash: x: You must set x
$ printf "%s\n" "${x:?You must set x}"  # Careful: should be used
bash: x: You must set x
$ x="*"
$ printf "%s\n" "${x:?You must set x}"  # Careful: should be used
*
$ printf "%s\n" ${x:?"You must set x"}  # Not quite careful enough
abc
def
ghi
$ x=
$ printf "%s\n" ${x:?"You must set x"}  # Not quite careful enough
bash: x: You must set x
$ unset x
$ printf "%s\n" ${x:?"You must set x"}  # Not quite careful enough
bash: x: You must set x
$ 

Обратите внимание, как значение в $x расширяется до первого *, а затем списка имен файлов, когда общее выражение не в двойных кавычках. Это то, что shellcheck рекомендует исправить. Я не проверял, что он не возражает против формы, в которой выражение заключено в двойные кавычки, но разумно предположить, что все будет в порядке.

559
Jonathan Leffler

Попробуй это:

[ -z "$STATE" ] && echo "Need to set STATE" && exit 1;
124
David Schlosnagle

Ваш вопрос зависит от используемой вами оболочки.

Bourne Shell оставляет очень мало на пути к тому, что вы ищете.

НО...

Это работает, почти везде.

Просто попробуйте и держитесь подальше от csh. Это было хорошо для прибамбасов, которые он добавил, по сравнению с Bourne Shell, но сейчас он действительно скрипит. Если вы мне не верите, просто попытайтесь отделить STDERR от csh! (-:

Здесь есть две возможности. Пример выше, а именно с использованием:

${MyVariable:=SomeDefault}

в первый раз вам нужно обратиться к $ MyVariable. Это занимает env. var MyVariable и, если он в данный момент не задан, присваивает значение SomeDefault переменной для дальнейшего использования.

У вас также есть возможность:

${MyVariable:-SomeDefault}

который просто заменяет SomeDefault на переменную, в которой вы используете эту конструкцию. Он не присваивает значение SomeDefault переменной, и значение MyVariable будет по-прежнему равно нулю после того, как встретится этот оператор.

55
Rob Wells

Конечно, самый простой подход - добавить переключатель -u к Shebang (строка в верхней части вашего скрипта), предполагая, что вы используете bash:

#!/bin/sh -u

Это приведет к завершению работы скрипта, если в нем скрываются какие-либо несвязанные переменные.

47
Paul Makkar
${MyVariable:=SomeDefault}

Если MyVariable установлено и не равно NULL, будет сброшено значение переменной (= ничего не происходит).
Иначе, MyVariable имеет значение SomeDefault.

Вышеприведенное попытается выполнить ${MyVariable}, поэтому, если вы просто хотите установить переменную, выполните:

MyVariable=${MyVariable:=SomeDefault}
37
Vincent Van Den Berghe

На мой взгляд, самая простая и наиболее совместимая проверка для #!/Bin/sh:

if [ "$MYVAR" = "" ]
then
   echo "Does not exist"
else
   echo "Exists"
fi

Опять же, это для/bin/sh и совместимо также со старыми системами Solaris.

20
Adriano

В bash 4.2 введен оператор -v, который проверяет, задано ли для имени значение любое, даже пустую строку.

$ unset a
$ b=
$ c=
$ [[ -v a ]] && echo "a is set"
$ [[ -v b ]] && echo "b is set"
b is set
$ [[ -v c ]] && echo "c is set"
c is set
15
chepner

Я всегда использовал:

if [ "x$STATE" == "x" ]; then echo "Need to set State"; exit 1; fi

Боюсь, не так уж и кратко.

Под CSH у вас есть $? STATE.

14
Mr.Ree

Для будущих людей, таких как я, я хотел сделать шаг вперед и параметризовать имя переменной, чтобы я мог перебрать список имен переменных переменного размера:

#!/bin/bash
declare -a vars=(NAME GITLAB_URL GITLAB_TOKEN)

for var_name in "${vars[@]}"
do
  if [ -z "$(eval "echo \$$var_name")" ]; then
    echo "Missing environment variable $var_name"
    exit 1
  fi
done
3
nicooga

Мы можем написать утверждение Nice, чтобы проверить сразу несколько переменных:

#
# assert if variables are set (to a non-empty string)
# if any variable is not set, exit 1 (when -f option is set) or return 1 otherwise
#
# Usage: assert_var_not_null [-f] variable ...
#
function assert_var_not_null() {
  local fatal var num_null=0
  [[ "$1" = "-f" ]] && { shift; fatal=1; }
  for var in "[email protected]"; do
    [[ -z "${!var}" ]] &&
      printf '%s\n' "Variable '$var' not set" >&2 &&
      ((num_null++))
  done

  if ((num_null > 0)); then
    [[ "$fatal" ]] && exit 1
    return 1
  fi
  return 0
}

Пример вызова:

one=1 two=2
assert_var_not_null one two
echo test 1: return_code=$?
assert_var_not_null one two three
echo test 2: return_code=$?
assert_var_not_null -f one two three
echo test 3: return_code=$? # this code shouldn't execute

Результат:

test 1: return_code=0
Variable 'three' not set
test 2: return_code=1
Variable 'three' not set
2
codeforester

Это тоже может быть способом:

if (set -u; : $HOME) 2> /dev/null
...
...

http://unstableme.blogspot.com/2007/02/checks-whether-envvar-is-set-or-not.html

1
Jadu Saikia

Ни одно из вышеперечисленных решений не сработало для моих целей, отчасти потому, что я проверил среду на наличие открытого списка переменных, которые необходимо установить перед началом длительного процесса. Я закончил с этим:

mapfile -t arr < variables.txt

EXITCODE=0

for i in "${arr[@]}"
do
   ISSET=$(env | grep ^${i}= | wc -l)
   if [ "${ISSET}" = "0" ];
   then
      EXITCODE=-1
      echo "ENV variable $i is required."
   fi
done

exit ${EXITCODE}
1
Gudlaugur Egilsson